//Release 0.7  Copyright 1993 by Kjell Nilsson, OOPS - ObjectWareHouse.  All Rights Reserved.

#import <appkit/appkit.h>

@interface OOPSTimer:Object
{
    float 			repeatTimeInterval;
	int				numberOfRepeats;
	int				numberOfRepeatsLeft;
	int				priority;
    int 			tag;

	BOOL			_auto;
	BOOL			_paused;
    id				_target;
    SEL				_action;
    SEL				_stopAction;
	DPSTimedEntry 	_timer;

}

- init;
- initRepeatTimeInterval:(float)aRepeatTimeInterval;
- initRepeatTimeInterval:(float)aRepeatTimeInterval target:aTarget action:(SEL)aSelector;
- free;
- awake;

- (int)priority;
- setPriority:(int)aPriority;
- (float)repeatTimeInterval;
- setRepeatTimeInterval:(float)someInterval;
- (int)numberOfRepeats;
- (int)numberOfRepeatsLeft;
- setNumberOfRepeats:(int)someNumber;
- setAutoStart:(BOOL)flag;
- (BOOL)autoStart;
- (BOOL)isRunning;

- target;
- setTarget:anObject;
- (SEL)action;
- setAction:(SEL)aSelector;
- (SEL)stopAction;
- setStopAction:(SEL)aSelector;
- (int)tag;
- setTag:(int)anInt;

- takeRepeatTimeIntervalFrom:sender;
- takeNumberOfRepeatsFrom:sender;

- startTimer:sender;
- pauseTimer:sender;
- stopTimer:sender;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

// IBSupport
- (const char *)getInspectorClassName; 
- (NXImage *)getIBImage;

@end
